﻿Type=Class
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
	Type TGAHeader(LengthOfField As Int, ColorMap As Int, ImageType As Int, OffsetOfColorMap As Short, _
		ColorsUsed As Short, BitsPerColorMap As Int, XCoordinate As Short, YCoordinate As Short, _
		ImageWidth As Short, ImageHeight As Short, BitsPerPixel As Int, Flags As Int)
	Private fx As JFX
	Private bc As ByteConverter
	Private raf As RandomAccessFile
	Private OutputJO, WriterJO As JavaObject
	Private fSize As Int
End Sub

Public Sub Initialize

End Sub

Public Sub Show(imgV As ImageView, fDir As String, fName As String)
	raf.Initialize(fDir, fName, True)		'Open file tga
	Dim r, g, b, n, a, j, k As Int
	Dim TGAHeader As TGAHeader
	TGAHeader.LengthOfField = GetByte
	TGAHeader.ColorMap = GetByte
	TGAHeader.ImageType = GetByte
	TGAHeader.OffsetOfColorMap = GetShort
	TGAHeader.ColorsUsed = GetShort
	TGAHeader.BitsPerColorMap = GetByte
	TGAHeader.XCoordinate = GetShort
	TGAHeader.yCoordinate = GetShort
	TGAHeader.ImageWidth = GetShort
	TGAHeader.ImageHeight = GetShort
	TGAHeader.BitsPerPixel = GetByte
	TGAHeader.Flags = GetByte
	If TGAHeader.ColorMap > 1 Then
		raf.Close
		Dim txt As String = "This is not a valid TGA file."
		CallSub2(Main, "toastMessage", txt )
		Return
	End If
	If TGAHeader.LengthOfField <> 0 Then 
		Dim bt1(TGAHeader.LengthOfField) As Byte
		raf.ReadBytes(bt1, 0, TGAHeader.LengthOfField, raf.CurrentPosition)
	End If
	fSize = raf.Size
	Dim sType As String							'Check file type
	Select Case TGAHeader.ImageType
		Case 0 
			sType = "No Image Data Available"
		Case 1
			sType = "Uncompressed Color Image"
		Case 2 
			sType = "Uncompressed RGB Image"
		Case 3
			sType = "Uncompressed Black & White Image"
		Case 9 
			sType = "Compressed Color Image"
		Case 10 
			sType = "Compressed RGB Image"
		Case 11
			sType = "Compressed Black & White Image"
	End Select
	
	If TGAHeader.ImageType = 3 Or TGAHeader.ImageType = 11 Or TGAHeader.ImageType = 32 Or TGAHeader.ImageType = 33 Then
		Dim txt As String = sType & CRLF & "This image type is not supported."
		CallSub2(Main, "toastMessage", txt )
		raf.Close
		Return
	Else If TGAHeader.BitsPerPixel <> 16 And TGAHeader.BitsPerPixel <> 24 And TGAHeader.BitsPerPixel <> 32 Then
		Dim txt As String = "Bits Per Pixel = " & TGAHeader.BitsPerPixel & CRLF & "We only support 16, 24, And 32 bits per pixel."
		CallSub2(Main, "toastMessage", txt )
		raf.Close
		Return
	End If
	Dim wdt As Int = TGAHeader.ImageWidth	'Get image width
	Dim hgt As Int = TGAHeader.ImageHeight	'Get image height
	imgV.SetSize(wdt, hgt)					'Resize ImageView
	
	'*****    Initialize WritableImage
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt, hgt))
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)
	
	'*****    Verifies whether the image is palette
	If TGAHeader.ImageType = 1 Or TGAHeader.ImageType = 9 Then
		Dim Palette(Power(2, TGAHeader.BitsPerPixel)) As Int
		For i = 0 To Power(2, TGAHeader.BitsPerPixel) - 1
			b = GetByte
			g = GetByte
			r = GetByte
			Palette(i) = fx.Colors.To32Bit(fx.Colors.RGB(r, g, b))
		Next
	End If
	
	'*****    Check Uncompressed image
	If TGAHeader.ImageType = 1 Or TGAHeader.ImageType = 2 Then
		Dim size As Int = TGAHeader.ImageWidth * (TGAHeader.BitsPerPixel / 8) 
		For y = TGAHeader.ImageHeight - 1 To 0 Step -1
			
			'*****    Checks if it is 16 bits per pixel
			If TGAHeader.BitsPerPixel = 16 Then
				For x = 0 To TGAHeader.ImageWidth - 1
					j = GetByte 'hi byte
					k = GetByte 'lo byte
					r = Bit.And(k, 127) / 4
					g = Bit.And(k, 3) * 8 + (Bit.And(j,  0xE0) / 32)
					b = Bit.And(j, 31)
					Dim clr As Int = fx.Colors.To32Bit(fx.Colors.RGB(r * 8, g * 8, b * 8))
					WriterJO.RunMethod("setArgb",Array As Object(x, y ,clr))
				Next
			
			'*****    Checks if it is 24 bits per pixel
			Else If TGAHeader.BitsPerPixel = 24 Then
				Dim Scanline() As Int = getScanline(size)
				For x = 0 To TGAHeader.ImageWidth - 1
					b = Scanline(x * 3)
					g = Scanline(x * 3 + 1)
					r = Scanline(x * 3 + 2)
					Dim clr As Int = fx.Colors.To32Bit(fx.Colors.RGB(r, g, b))
					WriterJO.RunMethod("setArgb",Array As Object(x, y ,clr))
				Next
			'*****	Checks if it is 32 bits per pixel
			Else If TGAHeader.BitsPerPixel = 32 Then
				Dim Scanline() As Int = getScanline(size)
				For x = 0 To TGAHeader.ImageWidth - 1
					b = Scanline(x * 4)
					g = Scanline(x * 4 + 1)
					r = Scanline(x * 4 + 2)
					a = Scanline(x * 4 + 3)
					Dim clr As Int = fx.Colors.To32Bit(fx.Colors.ARGB(a, r, g, b))
					WriterJO.RunMethod("setArgb",Array As Object(x, y ,clr))
				Next 
			Else
				Dim txt As String = "unknown error"
				CallSub2(Main, "toastMessage", txt )
				raf.Close
				Return
			End If
		Next 
		Scanline = Null
		Palette = Null

	'*****    Check Compressed image
	Else If TGAHeader.ImageType = 9 Or TGAHeader.ImageType = 10 Then
		y = TGAHeader.ImageHeight - 1
		x = 0
		Dim BytesPerPixel As Int = TGAHeader.BitsPerPixel / 8
		Do Until y < 0
			i = GetByte
			If i < 128 Then
				'*****    Checks if it is 16 bits per pixel
				If TGAHeader.BitsPerPixel = 16 Then
					For z = 0 To i
						j = GetByte 'hi byte
						k = GetByte 'lo byte
						r = Bit.And(k, 127) / 4
						g = Bit.And(k, 3) * 8 + (Bit.And(j, 0xE0) / 32)
						b = Bit.And(j, 31)
						Dim clr As Int = fx.Colors.To32Bit(fx.Colors.RGB(r * 8, g * 8, b * 8))
						WriterJO.RunMethod("setArgb",Array As Object(x, y ,clr))
						x = x + 1
					Next
				
				'*****    Checks if it is 24 bits per pixel
				Else If TGAHeader.BitsPerPixel = 24 Then
					Dim size As Int = (i + 1) * BytesPerPixel
					Dim Scanline() As Int = getScanline(size)
					For j = 0 To i
						b = Scanline(j * 3)
						g = Scanline(j * 3 + 1)
						r = Scanline(j * 3 + 2)
						Dim clr As Int = fx.Colors.To32Bit(fx.Colors.RGB(r, g, b))
						WriterJO.RunMethod("setArgb",Array As Object(x, y ,clr))
						x = x + 1
					Next
				
				'*****    Checks if it is 32 bits per pixel
				Else If TGAHeader.BitsPerPixel = 32 Then
					Dim size As Int = (i + 1) * BytesPerPixel
					Dim Scanline() As Int = getScanline(size)
					For j = 0 To i
						b = Scanline(j * 4)
						g = Scanline(j * 4 + 1)
						r = Scanline(j * 4 + 2)
						a = Scanline(j * 4 + 3)
						Dim clr As Int = fx.Colors.To32Bit(fx.Colors.ARGB(a, r, g, b))
						WriterJO.RunMethod("setArgb",Array As Object(x, y ,clr))
						x = x + 1
					Next
				End If
			else if i = 128 Then
			Else
				n = Bit.And(i, 127)

				'*****    Checks if it is 16 bits per pixel
				If TGAHeader.BitsPerPixel = 16 Then
					j = GetByte 'hi byte
					k = GetByte 'lo byte
					r = Bit.And(k, 127) / 4
					g = Bit.And(k, 3) * 8 + (Bit.And(j, 0xE0) / 32)
					b = Bit.And(j, 31)
					Dim clr As Int = fx.Colors.To32Bit(fx.Colors.RGB(r * 8, g * 8, b * 8))
					Dim z1 As Int = Min(x + n + 1, TGAHeader.ImageWidth-1)
					For z =  x To z1
						WriterJO.RunMethod("setArgb",Array As Object(z, y ,clr))
					Next'
					x = x + n + 1
				
				'*****    Checks if it is 24 bits per pixel
				Else If TGAHeader.BitsPerPixel = 24 Then
					b = GetByte
					g = GetByte
					r = GetByte
					Dim clr As Int = fx.Colors.To32Bit(fx.Colors.RGB(r, g, b))
					Dim z1 As Int = Min(x + n + 1, TGAHeader.ImageWidth-1)
					For z =  x To z1
						WriterJO.RunMethod("setArgb",Array As Object(z, y ,clr))
					Next'
					x = x + n + 1

				'*****    Checks if it is 32 bits per pixel
				Else If TGAHeader.BitsPerPixel = 32 Then
					b = GetByte
					g = GetByte
					r = GetByte
					a = GetByte
					For j = 0 To n
						Dim clr As Int = fx.Colors.To32Bit(fx.Colors.ARGB(a, r, g, b))
						WriterJO.RunMethod("setArgb",Array As Object(x + j, y ,clr))
					Next 
					x = x + n + 1
				End If
			End If
			If x >= TGAHeader.ImageWidth Then
				x = 0: y = y - 1
			End If
			If y < 0 Then Exit
		Loop
		Scanline = Null
		Palette = Null
	End If
	'Return Image Info
	Dim txt As String 
	txt = "File Size :" & fSize & CRLF
	txt = txt & "Image Width :" & TGAHeader.ImageWidth & CRLF
	txt = txt & "Image Height :" & TGAHeader.ImageHeight & CRLF
	txt = txt & "Bits Per Pixel :" & TGAHeader.BitsPerPixel & CRLF
	txt = txt & "Image Type :" & sType
	CallSub2(Main, "toastMessage", txt )
	'Set WritableImage in ImageView
	imgV.SetImage(OutputJO)
	raf.Close
End Sub

Private Sub getScanline(sz As Int) As Int()
	Dim lineTemp(sz) As Int 
	For i = 0 To sz - 1
		lineTemp(i) = raf.ReadUnsignedByte(raf.CurrentPosition)
	Next
	Return lineTemp
End Sub

Private Sub GetShort As Short
	Dim buffer(2) As Byte
	raf.ReadBytes(buffer, 0, 2, raf.CurrentPosition)
	Dim buf() As Byte = INV(buffer)
	Dim pS() As Short = bc.ShortsFromBytes(buf)
	Return pS(0)
End Sub

Private Sub GetByte As Int
	Dim varInt As Int = raf.ReadUnsignedByte(raf.CurrentPosition)
	Return varInt
End Sub

Private Sub INV(bt() As Byte) As Byte()
	Dim lg As Short = bt.Length
	Dim tmpB(lg) As Byte
	Dim ct As Short = lg
	For i = 0 To lg - 1
		ct = ct - 1
		tmpB(ct) = bt(i)
	Next
	Return tmpB
End Sub